diff -ruN --no-dereference --exclude=*.rej --exclude=*.orig --exclude=*.c.orig ocamlnet-4.1.9.clean/src/netsys/netsys_c_sem.c ocamlnet-4.1.9.patched/src/netsys/netsys_c_sem.c
--- src/netsys/netsys_c_sem.c	2021-03-24 16:20:14
+++ src/netsys/netsys_c_sem.c	2026-05-29 06:31:44
@@ -120,16 +120,16 @@
     int flags;
 
     init = Long_val(initv);
-    flags = convert_flag_list(flagsv, sem_open_flag_table);
+    flags = caml_convert_flag_list(flagsv, sem_open_flag_table);
     s = sem_open(String_val(namev),
 		 flags,
 		 Int_val(modev),
 		 init);
-    if (s == (sem_t *) SEM_FAILED) uerror("sem_open", namev);
+    if (s == (sem_t *) SEM_FAILED) caml_uerror("sem_open", namev);
     r = alloc_sem_block(s, 1);
     return r;
 #else
-    invalid_argument("Netsys.sem_open not available");
+    caml_invalid_argument("Netsys.sem_open not available");
 #endif
 }
 
@@ -141,13 +141,13 @@
 
     sb = Sem_block_val(srv);
     if (sb->sem_ptr == NULL)
-	invalid_argument ("Netsys.sem_close: stale semaphore");
+	caml_invalid_argument ("Netsys.sem_close: stale semaphore");
     code = sem_close(sb->sem_ptr);
-    if (code == -1) uerror("sem_close", Nothing);
+    if (code == -1) caml_uerror("sem_close", Nothing);
     sb->sem_ptr = NULL;
     return Val_unit;
 #else
-    invalid_argument("Netsys.sem_close not available");
+    caml_invalid_argument("Netsys.sem_close not available");
 #endif
 }
 
@@ -156,10 +156,10 @@
 #ifdef HAVE_POSIX_SEM_NAMED
     int code;
     code = sem_unlink(String_val(namev));
-    if (code == -1) uerror("sem_unlink", Nothing);
+    if (code == -1) caml_uerror("sem_unlink", Nothing);
     return Val_unit;
 #else
-    invalid_argument("Netsys.sem_unlink not available");
+    caml_invalid_argument("Netsys.sem_unlink not available");
 #endif
 }
 
@@ -175,13 +175,13 @@
     value r;
 
     init = Long_val(initv);
-    s = (sem_t *) (((char *) Bigarray_val(memv)->data) + Long_val(posv));
+    s = (sem_t *) (((char *) Caml_ba_array_val(memv)->data) + Long_val(posv));
     code = sem_init(s, Bool_val(psharedv), init);
-    if (code == -1) uerror("sem_init", Nothing);
+    if (code == -1) caml_uerror("sem_init", Nothing);
     r = alloc_sem_block(s, 0);
     return r;
 #else
-    invalid_argument("Netsys.sem_init not available");
+    caml_invalid_argument("Netsys.sem_init not available");
 #endif
 }
 
@@ -192,11 +192,11 @@
     sem_t *s;
     value r;
 
-    s = (sem_t *) (((char *) Bigarray_val(memv)->data) + Long_val(posv));
+    s = (sem_t *) (((char *) Caml_ba_array_val(memv)->data) + Long_val(posv));
     r = alloc_sem_block(s, 0);
     return r;
 #else
-    invalid_argument("Netsys.as_sem not available");
+    caml_invalid_argument("Netsys.as_sem not available");
 #endif
 }
 
@@ -209,13 +209,13 @@
 
     sb = Sem_block_val(srv);
     if (sb->sem_ptr == NULL)
-	invalid_argument ("Netsys.sem_destroy: stale semaphore");
+	caml_invalid_argument ("Netsys.sem_destroy: stale semaphore");
     code = sem_destroy(sb->sem_ptr);
-    if (code == -1) uerror("sem_destroy", Nothing);
+    if (code == -1) caml_uerror("sem_destroy", Nothing);
     sb->sem_ptr = NULL;
     return Val_unit;
 #else
-    invalid_argument("Netsys.sem_destroy not available");
+    caml_invalid_argument("Netsys.sem_destroy not available");
 #endif
 }
 
@@ -229,16 +229,16 @@
 
     sb = Sem_block_val(srv);
     if (sb->sem_ptr == NULL)
-	invalid_argument ("Netsys.sem_getvalue: stale semaphore");
+	caml_invalid_argument ("Netsys.sem_getvalue: stale semaphore");
     code = sem_getvalue(sb->sem_ptr, &sval);
-    if (code == -1) uerror("sem_getvalue", Nothing);
+    if (code == -1) caml_uerror("sem_getvalue", Nothing);
     if (sval < 0) sval = 0;
 #ifndef ARCH_SIXTYFOUR
-    if (sval > 1073741823) unix_error(EINVAL, "sem_getvalue", Nothing);
+    if (sval > 1073741823) caml_unix_error(EINVAL, "sem_getvalue", Nothing);
 #endif
     return Val_int(sval);
 #else
-    invalid_argument("Netsys.sem_getvalue not available");
+    caml_invalid_argument("Netsys.sem_getvalue not available");
 #endif
 }
 
@@ -250,12 +250,12 @@
 
     sb = Sem_block_val(srv);
     if (sb->sem_ptr == NULL)
-	invalid_argument ("Netsys.sem_post: stale semaphore");
+	caml_invalid_argument ("Netsys.sem_post: stale semaphore");
     code = sem_post(sb->sem_ptr);
-    if (code == -1) uerror("sem_post", Nothing);
+    if (code == -1) caml_uerror("sem_post", Nothing);
     return Val_unit;
 #else
-    invalid_argument("Netsys.sem_post not available");
+    caml_invalid_argument("Netsys.sem_post not available");
 #endif
 }
 
@@ -270,19 +270,19 @@
 
     sb = Sem_block_val(srv);
     if (sb->sem_ptr == NULL)
-	invalid_argument ("Netsys.sem_wait: stale semaphore");
+	caml_invalid_argument ("Netsys.sem_wait: stale semaphore");
     tag = Int_val(bv);
     s = sb->sem_ptr;
-    enter_blocking_section();
+    caml_enter_blocking_section();
     if (tag == 0)
 	code = sem_wait(s);
     else
 	code = sem_trywait(s);
-    leave_blocking_section();
-    if (code == -1) uerror("sem_wait", Nothing);
+    caml_leave_blocking_section();
+    if (code == -1) caml_uerror("sem_wait", Nothing);
     return Val_unit;
 #else
-    invalid_argument("Netsys.sem_wait not available");
+    caml_invalid_argument("Netsys.sem_wait not available");
 #endif
 }
 
diff -ruN --no-dereference --exclude=*.rej --exclude=*.orig --exclude=*.c.orig ocamlnet-4.1.9.clean/src/netsys/netsys_c_shm.c ocamlnet-4.1.9.patched/src/netsys/netsys_c_shm.c
--- src/netsys/netsys_c_shm.c	2021-03-24 16:20:14
+++ src/netsys/netsys_c_shm.c	2026-05-29 06:31:44
@@ -36,15 +36,15 @@
     int ret, cv_flags;
     char * p;
 
-    cv_flags = convert_flag_list(flags, shm_open_flag_table);
-    p = stat_alloc(string_length(path) + 1);
+    cv_flags = caml_convert_flag_list(flags, shm_open_flag_table);
+    p = caml_stat_alloc(caml_string_length(path) + 1);
     strcpy(p, String_val(path));
     ret = shm_open(p, cv_flags, Int_val(perm));
-    stat_free(p);
+    caml_stat_free(p);
     if (ret == -1) uerror("shm_open", path);
     CAMLreturn (Val_int(ret));
 #else
-    invalid_argument("Netsys.shm_open not available");
+    caml_invalid_argument("Netsys.shm_open not available");
 #endif
 }
 
@@ -58,7 +58,7 @@
     if (ret == -1) uerror("shm_unlink", path);
     return Val_unit;
 #else
-    invalid_argument("Netsys.shm_unlink not available");
+    caml_invalid_argument("Netsys.shm_unlink not available");
 #endif
 }
 
diff -ruN --no-dereference --exclude=*.rej --exclude=*.orig --exclude=*.c.orig ocamlnet-4.1.9.clean/src/netsys/netsys_c_spawn.c ocamlnet-4.1.9.patched/src/netsys/netsys_c_spawn.c
--- src/netsys/netsys_c_spawn.c	2021-03-24 16:20:14
+++ src/netsys/netsys_c_spawn.c	2026-05-29 06:31:44
@@ -112,15 +112,15 @@
        In the calling process, the mask is reset below at [exit].
     */
     code = sigfillset(&mask);
-    if (code == -1) unix_error(EINVAL, "netsys_spawn/sigfillset [000]", 
+    if (code == -1) caml_unix_error(EINVAL, "netsys_spawn/sigfillset [000]", 
 			       Nothing);
 #ifdef HAVE_PTHREAD
     code = pthread_sigmask(SIG_SETMASK, &mask, &save_mask);
-    if (code != 0) unix_error(code, "netsys_spawn/pthread_sigmask [001]", 
+    if (code != 0) caml_unix_error(code, "netsys_spawn/pthread_sigmask [001]", 
 			      Nothing);
 #else
     code = sigprocmask(SIG_SETMASK, &mask, &save_mask);
-    if (code == -1) uerror("netsys_spawn/sigprocmask [002]", Nothing);
+    if (code == -1) caml_uerror("netsys_spawn/sigprocmask [002]", Nothing);
 #endif
     memcpy(&spawn_mask, &save_mask, sizeof(sigset_t));
 
@@ -357,8 +357,8 @@
 
     /* exec the new program: */
     code = execve(String_val(v_cmd),
-		  sub_argv,
-		  sub_env);
+		  (char * const *) sub_argv,
+		  (char * const *) sub_env);
     if (code == -1) SUB_ERROR(errno, "netsys_spawn/execve [290]");
 
     SUB_ERROR(EINVAL, "netsys_spawn/assert_execve [291]");
@@ -473,11 +473,11 @@
     }
 
     if (uerror_errno != 0)
-	unix_error(uerror_errno, uerror_function, Nothing);
+	caml_unix_error(uerror_errno, uerror_function, Nothing);
 
     return return_value;
 #else
-     invalid_argument("netsys_spawn");
+     caml_invalid_argument("netsys_spawn");
 #endif
 }
 
@@ -614,7 +614,7 @@
 	    flags |= POSIX_SPAWN_SETPGROUP;
 	    break;
 	case 2: /* Pg_new_fg_group */
-	    invalid_argument
+	    caml_invalid_argument
 		("Netsys_posix.posix_spawn: Pg_new_fg_group not supported");
 	    break;
 	default:
@@ -638,7 +638,7 @@
 	    flags |= POSIX_SPAWN_SETSIGDEF;
 	    break;
 	case 1: /* Sig_ignore */
-	    invalid_argument
+	    caml_invalid_argument
 		("Netsys_posix.posix_spawn: Sig_ignore not supported");
 	    break;
 	case 2: /* Sig_mask */
@@ -800,15 +800,15 @@
     };
 
     if (uerror_errno != 0)
-	unix_error(uerror_errno, uerror_function, Nothing);
+	caml_unix_error(uerror_errno, uerror_function, Nothing);
 
     if (use_fork_exec != 0)
-	failwith("USE_FORK_EXEC");
+	caml_failwith("USE_FORK_EXEC");
 
     return return_value;
 
 #else
-     invalid_argument("netsys_posix_spawn not available");
+     caml_invalid_argument("netsys_posix_spawn not available");
 #endif
 }
 
diff -ruN --no-dereference --exclude=*.rej --exclude=*.orig --exclude=*.c.orig ocamlnet-4.1.9.clean/src/netsys/netsys_c_subprocess.c ocamlnet-4.1.9.patched/src/netsys/netsys_c_subprocess.c
--- src/netsys/netsys_c_subprocess.c	2021-03-24 16:20:14
+++ src/netsys/netsys_c_subprocess.c	2026-05-29 06:31:44
@@ -282,7 +282,7 @@
 	    (struct sigchld_atom *) malloc(sigchld_list_len * 
 					   sizeof(struct sigchld_atom));
 	if (sigchld_list == NULL) 
-	    failwith("Cannot allocate memory");
+	    caml_failwith("Cannot allocate memory");
 
 	for (k=0; k<sigchld_list_len; k++)
 	    sigchld_list[k].pid = 0;
@@ -295,14 +295,14 @@
 	code = errno;
 	sigchld_unlock(1);
 	errno = code;
-	uerror("sigaction", Nothing);
+	caml_uerror("sigaction", Nothing);
     };
 
     sigchld_unlock(1);
 
     return Val_unit;
 #else
-    invalid_argument("Netsys_posix.install_subprocess_handler not available");
+    caml_invalid_argument("Netsys_posix.install_subprocess_handler not available");
 #endif
 }
 
@@ -349,17 +349,17 @@
     int status, code, kill_flag;
     
     if (sigchld_list == NULL)
-	failwith("Netsys_posix.watch_subprocess: uninitialized");
+	caml_failwith("Netsys_posix.watch_subprocess: uninitialized");
 
     if (pipe(pfd) == -1)
-	uerror("pipe", Nothing);
+	caml_uerror("pipe", Nothing);
 
     if (fcntl(pfd[0], F_SETFD, FD_CLOEXEC) == -1) {
 	code = errno;
 	close(pfd[0]);
 	close(pfd[1]);
 	errno = code;
-	uerror("set_close_on_exec", Nothing);
+	caml_uerror("set_close_on_exec", Nothing);
     };
 
     if (fcntl(pfd[1], F_SETFD, FD_CLOEXEC) == -1) {
@@ -367,7 +367,7 @@
 	close(pfd[0]);
 	close(pfd[1]);
 	errno = code;
-	uerror("set_close_on_exec", Nothing);
+	caml_uerror("set_close_on_exec", Nothing);
     };
 
     pid = Int_val(pid_v);
@@ -391,7 +391,7 @@
 	if (sigchld_init_mt() == -1) {
 	    int saved_errno = errno;
 	    sigchld_unlock(1);
-	    unix_error(saved_errno,
+	    caml_unix_error(saved_errno,
 		       "netsys_watch_subprocess [delayed init]",
 		       Nothing);
 	}
@@ -425,7 +425,7 @@
 	    sigchld_unlock(1);
 	    close(pfd[0]);
 	    close(pfd[1]);
-	    failwith("Cannot allocate memory");
+	    caml_failwith("Cannot allocate memory");
 	};
 
 	for (k=old_size; k<sigchld_list_len; k++)
@@ -444,7 +444,7 @@
 	close(pfd[0]);
 	close(pfd[1]);
 	errno = code;
-	uerror("waitpid", Nothing);
+	caml_uerror("waitpid", Nothing);
     };
 
     if (code == 0) {  /* not yet terminated */
@@ -469,13 +469,13 @@
 
     sigchld_unlock(1);
 
-    r = alloc(2,0);
+    r = caml_alloc(2,0);
     Field(r,0) = Val_int(pfd[0]);
     Field(r,1) = Val_int(atom_idx);
     
     return r;
 #else
-    invalid_argument("Netsys_posix.watch_subprocess not available");
+    caml_invalid_argument("Netsys_posix.watch_subprocess not available");
 #endif
 }
 
@@ -498,7 +498,7 @@
 
     return Val_unit;
 #else
-    invalid_argument("Netsys_posix.ignore_subprocess not available");
+    caml_invalid_argument("Netsys_posix.ignore_subprocess not available");
 #endif
 }
 
@@ -521,7 +521,7 @@
 
     return Val_unit;
 #else
-    invalid_argument("Netsys_posix.forget_subprocess not available");
+    caml_invalid_argument("Netsys_posix.forget_subprocess not available");
 #endif
 }
 
@@ -554,15 +554,15 @@
 
     if (copy.terminated) {
 	if (WIFEXITED(copy.status)) {
-	    st = alloc_small(1, TAG_WEXITED);
+	    st = caml_alloc_small(1, TAG_WEXITED);
 	    Field(st, 0) = Val_int(WEXITSTATUS(copy.status));
 	}
 	else {
-	    st = alloc_small(1, TAG_WSIGNALED);
+	    st = caml_alloc_small(1, TAG_WSIGNALED);
 	    Field(st, 0) = 
 		Val_int(caml_rev_convert_signal_number(WTERMSIG(copy.status)));
 	};
-	r = alloc(1,0);
+	r = caml_alloc(1,0);
 	Field(r, 0) = st;
     }
     else {
@@ -571,7 +571,7 @@
 
     return r;
 #else
-    invalid_argument("Netsys_posix.forget_subprocess not available");
+    caml_invalid_argument("Netsys_posix.forget_subprocess not available");
 #endif
 }
 
@@ -597,7 +597,7 @@
     return Val_unit;
 
 #else
-    invalid_argument("Netsys_posix.kill_subprocess not available");
+    caml_invalid_argument("Netsys_posix.kill_subprocess not available");
 #endif
 }
 
@@ -634,7 +634,7 @@
     return Val_unit;
 
 #else
-    invalid_argument("Netsys_posix.killpg_subprocess not available");
+    caml_invalid_argument("Netsys_posix.killpg_subprocess not available");
 #endif
 }
 
@@ -648,7 +648,7 @@
     int k;
 
     if (sigchld_list == NULL)
-	failwith("Netsys_posix.watch_subprocess: uninitialized");
+	caml_failwith("Netsys_posix.watch_subprocess: uninitialized");
 
     sig = caml_convert_signal_number(Int_val(sig_v));
     o_flag = Bool_val(o_flag_v);
@@ -672,7 +672,7 @@
     return Val_unit;
 
 #else
-    invalid_argument("Netsys_posix.kill_all_subprocesses not available");
+    caml_invalid_argument("Netsys_posix.kill_all_subprocesses not available");
 #endif
 }
 
@@ -686,7 +686,7 @@
     pid_t pgid;
 
     if (sigchld_list == NULL)
-	failwith("Netsys_posix.watch_subprocess: uninitialized");
+	caml_failwith("Netsys_posix.watch_subprocess: uninitialized");
 
     sig = caml_convert_signal_number(Int_val(sig_v));
     o_flag = Bool_val(o_flag_v);
@@ -722,7 +722,7 @@
     return Val_unit;
 
 #else
-    invalid_argument("Netsys_posix.killpg_all_subprocesses not available");
+    caml_invalid_argument("Netsys_posix.killpg_all_subprocesses not available");
 #endif
 }
 
diff -ruN --no-dereference --exclude=*.rej --exclude=*.orig --exclude=*.c.orig ocamlnet-4.1.9.clean/src/netsys/netsys_c_syslog.c ocamlnet-4.1.9.patched/src/netsys/netsys_c_syslog.c
--- src/netsys/netsys_c_syslog.c	2021-03-24 16:20:14
+++ src/netsys/netsys_c_syslog.c	2026-05-29 06:31:44
@@ -68,6 +68,7 @@
     LOG_CONS, LOG_NDELAY, LOG_ODELAY, LOG_NOWAIT, LOG_PID
 };
 
+// FIXME DOMAINS
 static char *ident_buf = NULL;
 #define IDENT_BUF_LEN 256
 #endif
@@ -86,7 +87,7 @@
     id=NULL;
     if (Is_block(ident)) {
 	if (ident_buf == NULL) {
-	    ident_buf = stat_alloc(IDENT_BUF_LEN);
+	    ident_buf = caml_stat_alloc(IDENT_BUF_LEN);
 	};
 	strncpy(ident_buf, 
 		String_val(Field(ident, 0)),
@@ -94,12 +95,12 @@
 	ident_buf[IDENT_BUF_LEN-1] = 0;
 	id=ident_buf;
     };
-    options = convert_flag_list(opts, syslog_opt_flags);
+    options = caml_convert_flag_list(opts, syslog_opt_flags);
     facility = syslog_fac_flags[Int_val(fac)];
     openlog(id, options, facility);
     return Val_unit;
 #else
-    invalid_argument("Netsys_posix.openlog not available");
+    caml_invalid_argument("Netsys_posix.openlog not available");
 #endif
 }
 
@@ -114,7 +115,7 @@
     syslog(facility | level, "%s", String_val(msg));
     return Val_unit;
 #else
-    invalid_argument("Netsys_posix.syslog not available");
+    caml_invalid_argument("Netsys_posix.syslog not available");
 #endif
 }
 
@@ -125,7 +126,7 @@
     closelog();
     return Val_unit;
 #else
-    invalid_argument("Netsys_posix.closelog not available");
+    caml_invalid_argument("Netsys_posix.closelog not available");
 #endif
 }
 
